Bug 89665 - find-and-replace slowdown due to i18npool transliteration code
Summary: find-and-replace slowdown due to i18npool transliteration code
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Linguistic (show other bugs)
Version:
(earliest affected)
4.3.0.4 release
Hardware: Other All
: medium normal
Assignee: Michael Stahl (CIB)
URL:
Whiteboard: target:4.5.0 target:4.4.2 target:4.3.7
Keywords: perf, regression
Depends on:
Blocks:
 
Reported: 2015-02-25 22:14 UTC by Michael Stahl (CIB)
Modified: 2015-12-15 11:40 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Stahl (CIB) 2015-02-25 22:14:59 UTC
See 80715 for an example document and repro
(basically regex search for "$", replace all).
Comment 1 Michael Stahl (CIB) 2015-02-25 22:23:38 UTC
the fix for bug 77123 introduced a second transliteration module
that is enabled by default, and a new "ignore kashida CTL"
option on the Find-and-Replace dialog that is enabled by default.

author	Faisal M. Al-Otaibi <fmalotaibi@kacst.edu.sa>	2014-04-08 06:42:20 (GMT)
commit	d2771b63b94a8aae3c25c83e9dae9f83242f46c1

fdo#77123: Add option ignore kashida to the search


the problem with that is that it caused a switch to a slow path
in the transliteration service that is very slow indeed
at copying between uno::Sequences, taking up most of
the Replace CPU time according to callgrind.
Comment 2 Commit Notification 2015-02-25 23:13:04 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=88d4b2fb08b983531b1e0abc71b07f4bdecdc925

tdf#89665: i18npool: fix pathological transliterate slow-path

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 3 Commit Notification 2015-02-26 19:13:39 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-4-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=d1057d2fc205dc47d845b3e5738a54c68824e90b&h=libreoffice-4-4

tdf#89665: i18npool: fix pathological transliterate slow-path

It will be available in 4.4.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 4 Commit Notification 2015-02-26 19:14:55 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-4-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=5e28588770fa27eb210d004aec2f56e28fe01252&h=libreoffice-4-3

tdf#89665: i18npool: fix pathological transliterate slow-path

It will be available in 4.3.7.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 5 Commit Notification 2015-03-09 23:23:09 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=806ced87cfe3da72df0d8e4faf5b82535fc7d1b7

tdf#89665: i18npool: speed up TextSearch::searchForward()

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 6 Commit Notification 2015-03-09 23:23:32 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=666fb8b7bc210be6d785515bc7660e5a5d19b82e

tdf#89665: i18npool: speed up TextSearch::searchBackward()

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 7 Michael Stahl (CIB) 2015-03-10 12:16:19 UTC
fixed on master
Comment 8 Commit Notification 2015-03-10 19:09:55 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-4-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=4bae2ea3b57cb88b34bf8a9eade7ab0a950e0185&h=libreoffice-4-4

tdf#89665: i18npool: speed up TextSearch::searchForward()

It will be available in 4.4.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2015-03-10 19:11:09 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-4-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=cfaeddd9ed07fad75182eb0cd040e63d08502b5e&h=libreoffice-4-4

tdf#89665: i18npool: speed up TextSearch::searchBackward()

It will be available in 4.4.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Robinson Tryon (qubit) 2015-12-15 11:40:22 UTC
Migrating Whiteboard tags to Keywords: (perf)
[NinjaEdit]